/*
this example explains how to use the server FROM PYTHON.
It is just a basic example that receives OSC messages from the server widgets.
In this case the widgets are described in a python file that extends the server. We just 
need to create listeners to each of the widgets created there and define here what those
widgets will control in the sound engine.
Note that to create your own file you just want to edit the second half of the file. 
*/

1 => int on;

// init OSC /////////////////////////////////////////
OscSend send; //send OSC
send.setHost( "localhost", 9000);
OscRecv recv; //recv OSC
9001 => recv.port;
recv.listen(); // start listening (launch thread)


// OSC classes and functions ////
class OscListener { // general listener template
    OscEvent e;
                    
    fun void action(){} //to be extended

    fun void bind( string arg ){
            recv.event(arg) @=> e; // bind event to address
            spork ~ oscShred( ); // start listening to incomming osc
    }
                    
    fun void oscShred() {
            while (on){
                    e => now;
                    if ( e.nextMsg()){ action(); }
            }
            //<<<"exiting shred", me>>>;
            //machine.remove( s.id() );
    }
}
/////////////////////////////////////////

class StatusListener extends OscListener{
    fun void action(){
        if (e.getInt()){
            <<<"chuck: connected msg received from widgets server">>>;
        } else {
            <<<"chuck: widgets server just quit">>>;
            0 => on;
        }
    }
}

StatusListener statusLis;
statusLis.bind( "/status, i" );

send.startMsg( "/status", "i" );
1 => send.addInt; // send connected message to graphics



////////////////////////////////
////////////////////////////////
// edit stuff below ////////////
////////////////////////////////
////////////////////////////////




///////// widgets Listeners
// define what each widget will be controlling
class Toggle1Listener extends OscListener{
    fun void action(){ <<<"chuck: toogle1", e.getInt()>>>; }
}
class Button1Listener extends OscListener{
    fun void action(){ <<<"chuck: button1", e.getInt()>>>; }
}
class Slider1Listener extends OscListener{
    fun void action(){ <<<"chuck: slider1", e.getInt()>>>; }
}
class Slider2Listener extends OscListener{
    fun void action(){ <<<"chuck: slider2", e.getInt()>>>; }
}
class Choice1Listener extends OscListener{
    fun void action(){ <<<"chuck: choice1", e.getString()>>>; }
}
class Radio1Listener extends OscListener{
    fun void action(){ <<<"chuck: radio1", e.getString()>>>; }
}
class Num1Listener extends OscListener{
    fun void action(){ <<<"chuck: num1", e.getInt()>>>; }
}

// widgets listeners//
// maps which osc addressed are binded to which listeners, must be
// consistant with the addresses defined in the python file
Button1Listener buttonLis; // button
buttonLis.bind( "/button1, i" );
Toggle1Listener toggleLis; // toggle
toggleLis.bind( "/toggle1, i" );
Slider1Listener sl1Lis; // horizonal slider
sl1Lis.bind( "/slider1, i" );
Slider2Listener sl2Lis; //vertical slider
sl2Lis.bind( "/slider2, i" );
Choice1Listener cho1Lis; // choice
cho1Lis.bind( "/choice1, s" );
Radio1Listener radio1Lis; // radio box
radio1Lis.bind( "/radio1, s" );
Num1Listener num1Lis; // number
num1Lis.bind( "/number1, i" );



<<<"chuck osc receiver up and runing ...">>>;

//entering main loop //
while (on){ // quits when on is false
	0.2::second => now; 
}

<<<"quiting ChucK">>>; //print quit

